## ncurses 6.4+20230625

=== debian/changelog ===
ncurses (6.4+20230625-2) unstable; urgency=medium

  * Save some build time by not building the static libraries along the
    shared ones, they are configured and built separately.
  * Get rid of debian/rxvt.ti (Closes: #1037071) and record relevant
    Debian changes in a new patch 02-debian-rxvt.diff.
    - Set kbs=^? according to the Debian keyboard policy.
    - Provide rxvt-m as an alias to rxvt-basic.
  * Pass "-Xusr/lib" to dh_missing in the binary-indep target to work
    around spurious failures in full builds (see #1039941).
  * Drop patch debian-alacritty.diff.  Alacritty users should upgrade vim
    to version 2:9.0.1658-1 or higher, or start vim with $TERM set to
    xterm-256color.
  * Take over the foot and foot-direct terminfo entries from the
    foot-terminfo package in ncurses-term (see #1041685).
    - Add a versioned Provides on foot-terminfo to ncurses-term in order
      to help with partial upgrades.

 -- Sven Joachim <svenjoac@gmx.de>  Sun, 23 Jul 2023 16:58:09 +0200

ncurses (6.4+20230625-1) unstable; urgency=low

  * New upstream patchlevel.
  * Add Breaks against tmux (<< 3.3a-4) to libtinfo6 (see #1038269).
  * Remove Replaces/Conflicts/Provides relationships with pre-buster
    packages in lib{32,64}ncurses-dev.
  * Set maintainer to ncurses@packages.debian.org, add Craig to Uploaders.
  * Stop stripping libncurses++w.a manually.
  * Move the cons25-debian terminfo entry from ncurses-base to
    ncurses-term, it had only been used in Debian GNU/kFreeBSD 6.0.
  * Tighten the dependency of ncurses-term on ncurses-base, so that they
    are always from the same version.
  * New patch debian-alacritty.diff: remove xterm+focus from the alacritty
    terminfo entry, as it triggers misbehavior in Vim version before
    9.0.1619 (see #1038401).
  * Stop building the libtinfo5, libncurses5 and libncursew5 packages
    (Closes: #1025964).
  * Upload to unstable.

 -- Sven Joachim <svenjoac@gmx.de>  Sat, 01 Jul 2023 10:15:14 +0200

ncurses (6.4+20230603-1) experimental; urgency=low

  * New upstream patchlevel.
    - Improve checks for malformed terminfo data (report/analysis by
      Jonathan Bar Or, Michael Pearse, Emanuele Cozzi (CVE-2023-29491,
      Closes: #1034372)).
    - Drop compatibility with obsolete versions of tack, e.g., pre-1.08
      (Closes: #1034549).
  * Drop cherry-picked patches, applied upstream.
  * Configure with "--disable-setuid-environ" instead of
    "--disable-root-environ" and drop patch debian-env-access.diff.
  * Refresh remaining Debian patches.
    - Drop the hunk for screen-base from 02-debian-backspace.diff.
      Upstream sets kbs in screen-base to xterm+kbs now, so this is
      handled via the "--with-xterm-kbs" configure option.
  * Configure with "--disable-root-access" to further restrict programs
    running with elevated privileges.
  * Update symbols files for the new symbols tiparm_s and tiscan_s,
    and the newly exported symbols _nc_safe_fopen and _nc_safe_open3.
  * Remove the ncurses{w,}5-config compatibility symlinks
    (Closes: #1029977).
  * Remove old upstream SHA1 signing key C52048C0C0748FEE from
    debian/upstream/signing-key.asc.
  * Export ARFLAGS = -crv in debian/rules to ensure deterministic static
    libraries (see #1029404).
  * Stop building the empty transitional packages libtinfo-dev
    and libncurses{,w}5-dev (Closes: #1032708, #1032740, #1032741).
  * Move the ncurses-base terminfo files to /usr/share/terminfo
    (Closes: #1028202, #622286).
    - Add a Breaks on cryptsetup-initramfs (<< 2:2.6.1) to ncurses-base
      (see #1028234).
  * Remove various Breaks/Replaces relationships with package versions
    predating buster.
  * Update years in debian/copyright.

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 15 Jun 2023 18:34:20 +0200

=== debian/control ===
Source: ncurses
Section: libs
Priority: required
Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
Uploaders: Sven Joachim <svenjoac@gmx.de>, Craig Small <csmall@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgpm-dev [linux-any],
               pkg-config,
               autoconf-dickey (>= 2.52+20210509),
Build-Depends-Arch: g++-multilib [amd64 i386 powerpc ppc64 s390 sparc] <!nobiarch>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ncurses
Vcs-Git: https://salsa.debian.org/debian/ncurses.git
Homepage: https://invisible-island.net/ncurses/

Package: ncurses-base
Architecture: all
Section: misc
Essential: yes
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: ncurses-runtime
Replaces: ncurses-term (<< 6.4+20230603)
Breaks: neovim (<< 0.6.0), vim-common (<< 2:9.0.1000-2),
        ncurses-term (<< 6.4+20230625), cryptsetup-initramfs (<< 2:2.6.1)
Description: basic terminal type definitions
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains terminfo data files to support the most common types of
 terminal, including ansi, dumb, linux, rxvt, screen, sun, vt100, vt102, vt220,
 vt52, and xterm.

Package: ncurses-term
Architecture: all
Section: misc
Priority: standard
Multi-Arch: foreign
Depends: ncurses-base (= ${binary:Version}), ${misc:Depends}
Replaces: alacritty (<< 0.3.4~), jfbterm (<< 0.4.7-10),
          kon2 (<< 0.3.9b-21), libiterm1 (<< 0.5-9), tn5250 (<< 0.17.4-3),
          ncurses-base (<< 6.4+20230625), foot-terminfo (<< 1.15.1-2)
Breaks: vim-common (<< 2:9.0.1000-2), foot-terminfo (<< 1.15.1-2)
Provides: foot-terminfo (= ${binary:Version})
Description: additional terminal type definitions
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains all of the numerous terminal definitions not found in
 the ncurses-base package.

Package: libtinfo6
Architecture: any
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: tmux (<< 3.3a-4)
Description: shared low-level terminfo library for terminal handling
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared low-level terminfo library.

Package: libtinfo6-udeb
Package-Type: udeb
Section: debian-installer
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!noudeb>
Description: shared low-level terminfo library for terminal handling - udeb
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the stripped-down udeb version of shared low-level
 terminfo library.

Package: libncurses6
Architecture: any
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libtinfo6 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libgpm2 [linux-any]
Breaks: cowdancer (<< 0.89~)
Description: shared libraries for terminal handling
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.

Package: libncurses-dev
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libtinfo6 (= ${binary:Version}), libncurses6 (= ${binary:Version}),
         libncursesw6 (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Conflicts: ncurses-dev
Replaces: ncurses-dev
Provides: libncurses5-dev (= ${binary:Version}),
          libncursesw5-dev (= ${binary:Version}),
          libtinfo-dev (= ${binary:Version}), ncurses-dev
Suggests: ncurses-doc
Description: developer's libraries for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.

Package: libncursesw6
Architecture: any
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: libtinfo6 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: libgpm2 [linux-any]
Description: shared libraries for terminal handling (wide character support)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.

Package: libncursesw6-udeb
Package-Type: udeb
Section: debian-installer
Architecture: any
Priority: optional
Depends: libtinfo6-udeb (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!noudeb>
Description: shared libraries for terminal handling (wide character support) - udeb
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the stripped-down udeb version of shared libraries
 necessary to run programs compiled with ncursesw, which includes support
 for wide characters.

Package: lib64tinfo6
Architecture: i386 powerpc sparc s390
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared low-level terminfo library for terminal handling (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared low-level terminfo library.
 .
 This package supports the 64-bit ABI variant of your system's architecture.

Package: lib64ncurses6
Architecture: i386 powerpc sparc s390
Priority: optional
Depends: lib64tinfo6 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared libraries for terminal handling (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.
 .
 This package supports the 64-bit ABI variant of your system's
 architecture.

Package: lib64ncursesw6
Architecture: i386 powerpc sparc s390
Priority: optional
Depends: lib64tinfo6 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared libraries for terminal handling (wide character support) (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.
 .
 This package supports the 64-bit ABI variant of your system's
 architecture.

Package: lib64ncurses-dev
Architecture: i386 powerpc sparc s390
Section: libdevel
Priority: optional
Depends: lib64ncurses6 (= ${binary:Version}),
	 lib64ncursesw6 (= ${binary:Version}),
         lib64tinfo6 (= ${binary:Version}),
         libncurses-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
Suggests: ncurses-doc
Build-Profiles: <!nobiarch>
Description: developer's libraries for ncurses (64-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.
 .
 This package supports the 64-bit ABI variant of your system's
 architecture.

Package: lib32tinfo6
Architecture: amd64 ppc64
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared low-level terminfo library for terminal handling (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared low-level terminfo library.
 .
 This package supports the 32-bit ABI variant of your system's architecture.

Package: lib32ncurses6
Architecture: amd64 ppc64
Priority: optional
Depends: lib32tinfo6 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared libraries for terminal handling (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncurses.
 .
 This package supports the 32-bit ABI variant of your system's
 architecture.

Package: lib32ncursesw6
Architecture: amd64 ppc64
Priority: optional
Depends: lib32tinfo6 (= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!nobiarch>
Description: shared libraries for terminal handling (wide character support) (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the shared libraries necessary to run programs
 compiled with ncursesw, which includes support for wide characters.
 .
 This package supports the 32-bit ABI variant of your system's
 architecture.

Package: lib32ncurses-dev
Architecture: amd64 ppc64
Section: libdevel
Priority: optional
Depends: lib32ncurses6 (= ${binary:Version}),
	 lib32ncursesw6 (= ${binary:Version}),
         lib32tinfo6 (= ${binary:Version}),
         libncurses-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
Suggests: ncurses-doc
Build-Profiles: <!nobiarch>
Description: developer's libraries for ncurses (32-bit)
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the header files, static libraries
 and symbolic links that developers using ncurses will need.
 .
 This package supports the 32-bit ABI variant of your system's
 architecture.

Package: ncurses-bin
Architecture: any
Section: utils
Essential: yes
Pre-Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: terminal-related programs and man pages
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains the programs used for manipulating the terminfo
 database and individual terminfo entries, as well as some programs for
 resetting terminals and such.

Package: ncurses-examples
Architecture: any
Section: misc
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!pkg.ncurses.noexamples>
Description: test programs and examples for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains programs demonstrating the possibilities of
 ncurses and testing the library. The examples include an
 analog/digital clock and several classic programs such as solitaire,
 battleships, a knight's tour on a chess board, the towers of Hanoi
 and several others.

Package: ncurses-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: developer's guide and documentation for ncurses
 The ncurses library routines are a terminal-independent method of
 updating character screens with reasonable optimization.
 .
 This package contains an introduction to writing programs with
 ncurses a guide to the internals of the ncurses library.  It also
 includes the libraries' man pages.
 .
 Non-developers likely have little use for this package.

=== debian/rules ===
#!/usr/bin/make -f
# This file has gone through many maintainers.  Mostly rewritten
# by Daniel Jacobowitz.

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS) -Otarget
endif

export CFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get CFLAGS)
export CPPFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get CXXFLAGS)
export LDFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get LDFLAGS)
export BUILD_CFLAGS := $(CFLAGS)
export BUILD_CPPFLAGS := $(CPPFLAGS)
export BUILD_LDFLAGS := $(LDFLAGS)
export ARFLAGS = -crv

include /usr/share/dpkg/architecture.mk

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
HOST_CC ?= $(DEB_HOST_GNU_TYPE)-gcc
HOST_CXX ?= $(DEB_HOST_GNU_TYPE)-g++
else
HOST_CC ?= gcc
HOST_CXX ?= g++
endif

# These are important since this is a library package
soname=6
sodepver = (>= 6.3+20220423)

# Name our packages
package-base=ncurses-base
package-bin=ncurses-bin
package-lib=libncurses$(soname)
package-lib-32=lib32ncurses$(soname)
package-lib-64=lib64ncurses$(soname)
package-ti=libtinfo$(soname)
package-ti-32=lib32tinfo$(soname)
package-ti-64=lib64tinfo$(soname)
package-libw=libncursesw$(soname)
package-libw-32=lib32ncursesw$(soname)
package-libw-64=lib64ncursesw$(soname)
package-dev-32=lib32ncurses-dev
package-dev-64=lib64ncurses-dev
package-term=ncurses-term
package-examples=ncurses-examples

workdir=$(shell pwd)
tempdir=debian/tmp
fulltempdir=$(workdir)/$(tempdir)

srcdir=$(shell pwd)
relsrcdir=..
objdir=$(srcdir)/obj
objdir-static=$(srcdir)/obj-static
objdir-32=$(srcdir)/obj-32
objdir-64=$(srcdir)/obj-64
wobjdir=$(srcdir)/obj-wide
wobjdir-static=$(srcdir)/obj-wide-static
wobjdir-32=$(srcdir)/obj-wide-32
wobjdir-64=$(srcdir)/obj-wide-64
objdir-test=$(srcdir)/obj-test

autogen-files := debian/libtermcap.so

ifeq ($(DEB_HOST_ARCH),i386)
build_64_target = x86_64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64 build-wide-64
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
build_64_target = powerpc64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64 build-wide-64
endif

ifeq ($(DEB_HOST_ARCH),s390)
build_64_target = s390x-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64 build-wide-64
endif

ifeq ($(DEB_HOST_ARCH),sparc)
build_64_target = sparc64-$(DEB_HOST_GNU_SYSTEM)
build_64 = build-64 build-wide-64
endif

ifeq ($(DEB_HOST_ARCH),amd64)
build_32_target = i686-$(DEB_HOST_GNU_SYSTEM)
build_32 = build-32 build-wide-32
endif

ifeq ($(DEB_HOST_ARCH),ppc64)
build_32_target = powerpc-$(DEB_HOST_GNU_SYSTEM)
build_32 = build-32 build-wide-32
endif

ifneq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
override build_32=
override build_64=
endif

ifeq (,$(filter pkg.ncurses.noexamples,$(DEB_BUILD_PROFILES)))
build_examples = build-test
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
with_mouse = --with-gpm
else
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
with_mouse = --without-sysmouse
endif
endif

CONFARGS =	--prefix=/usr \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--with-shared \
		--mandir=/usr/share/man \
		--with-manpage-format=normal \
		--without-profile --without-debug \
		--disable-rpath --enable-echo \
		--disable-stripping \
		--enable-const \
		--enable-pc-files \
		--with-pkg-config-libdir=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-install-prefix=$(fulltempdir) \
		--without-ada \
		--without-tests \
		--without-progs \
		$(with_mouse) \
		--enable-symlinks \
		--disable-setuid-environ \
		--disable-root-access \
		--disable-termcap \
		--with-default-terminfo-dir=/etc/terminfo \
		--with-terminfo-dirs="/etc/terminfo:/lib/terminfo:/usr/share/terminfo" \
		--with-ticlib=tic \
		--with-termlib=tinfo \
		--with-versioned-syms \
		--disable-wattr-macros \
		--disable-relink \
		--disable-pkg-ldflags \
		--enable-overwrite \
		--with-xterm-kbs=del

CONFARGS-TEST =	--prefix=/usr \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--bindir=/usr/libexec/ncurses-examples \
		--datadir=/usr/share/ncurses-examples \
		--disable-stripping \
		--with-x11-rgb=/etc/X11/rgb.txt \
		--with-ncursesw \
		--with-curses-dir=$(wobjdir)

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CONFARGS += --with-build-cc=gcc --host=$(DEB_HOST_GNU_TYPE)
CONFARGS-TEST += --host=$(DEB_HOST_GNU_TYPE)
endif

# Exclude terminfo entries shipped by other Debian packages so that we do
# not begin shipping them by accident.
badterminfo = f/fbterm k/kbtin x/xterm-kitty K/KBtin

ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
# Force necessary configure checks which do not work when
# cross compiling; all Debian platforms return unsigned char
# and working poll for these configure checks.
export cf_cv_type_of_bool=unsigned char
export cf_cv_working_poll=yes
export cf_cv_gpm_soname=libgpm.so.2
endif

config.guess-stamp:
	dh_update_autotools_config
	dh_autoreconf debian/autoconf.sh
	touch $@

$(objdir)/config.status: config.guess-stamp
	test -d $(objdir) || mkdir $(objdir)
	cd $(objdir) && $(relsrcdir)/configure \
		$(CONFARGS) \
		--without-normal

$(objdir-static)/config.status: config.guess-stamp
	test -d $(objdir-static) || mkdir $(objdir-static)
	cd $(objdir-static) && $(relsrcdir)/configure \
		$(CONFARGS) \
		--without-shared \
		--without-gpm

$(objdir-32)/config.status: config.guess-stamp
	test -d $(objdir-32) || mkdir $(objdir-32)

	cf_cv_type_of_bool='unsigned char'; export cf_cv_type_of_bool; \
	cf_cv_working_poll=yes; export cf_cv_working_poll; \
	cd $(objdir-32) && CC="$(HOST_CC) -m32" \
		BUILD_CC="gcc" CXX="$(HOST_CXX) -m32" \
		$(relsrcdir)/configure \
		$(CONFARGS) \
		--host=$(build_32_target) \
		--without-gpm \
		--libdir=/usr/lib32

$(objdir-64)/config.status: config.guess-stamp
	test -d $(objdir-64) || mkdir $(objdir-64)

	cf_cv_type_of_bool='unsigned char'; export cf_cv_type_of_bool; \
	cf_cv_working_poll=yes; export cf_cv_working_poll; \
	cd $(objdir-64) && CC="$(HOST_CC) -m64" \
		BUILD_CC="gcc" CXX="$(HOST_CXX) -m64" \
		$(relsrcdir)/configure \
		$(CONFARGS) \
		--host=$(build_64_target) \
		--without-gpm \
		--libdir=/usr/lib64

$(wobjdir)/config.status: config.guess-stamp
	test -d $(wobjdir) || mkdir $(wobjdir)
	cd $(wobjdir) && $(relsrcdir)/configure \
		$(CONFARGS) \
		--without-normal \
		--with-progs \
		--enable-widec

$(wobjdir-static)/config.status: config.guess-stamp
	test -d $(wobjdir-static) || mkdir $(wobjdir-static)
	cd $(wobjdir-static) && $(relsrcdir)/configure \
		$(CONFARGS) \
		--without-shared \
		--without-gpm \
		--enable-widec

$(wobjdir-32)/config.status: config.guess-stamp
	test -d $(wobjdir-32) || mkdir $(wobjdir-32)

	cf_cv_type_of_bool='unsigned char'; export cf_cv_type_of_bool; \
	cf_cv_working_poll=yes; export cf_cv_working_poll; \
	cd $(wobjdir-32) && CC="$(HOST_CC) -m32" \
		BUILD_CC="gcc" CXX="$(HOST_CXX) -m32" \
		$(relsrcdir)/configure \
		$(CONFARGS) \
		--host=$(build_32_target) \
		--without-gpm \
		--enable-widec \
		--libdir=/usr/lib32

$(wobjdir-64)/config.status: config.guess-stamp
	test -d $(wobjdir-64) || mkdir $(wobjdir-64)

	cf_cv_type_of_bool='unsigned char'; export cf_cv_type_of_bool; \
	cf_cv_working_poll=yes; export cf_cv_working_poll; \
	cd $(wobjdir-64) && CC="$(HOST_CC) -m64" \
		BUILD_CC="gcc" CXX="$(HOST_CXX) -m64" \
		$(relsrcdir)/configure \
		$(CONFARGS) \
		--host=$(build_64_target) \
		--without-gpm \
		--enable-widec \
		--libdir=/usr/lib64

$(objdir-test)/config.status: build-wide config.guess-stamp
	test -d $(objdir-test) || mkdir $(objdir-test)
	export LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(wobjdir)/lib && \
	cd $(objdir-test) && \
		PKG_CONFIG_LIBDIR=$(wobjdir)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		$(relsrcdir)/test/configure $(CONFARGS-TEST)

build-indep: build-normal build-wide
	touch $@

build-arch build: build-indep build-static build-wide-static $(build_examples) \

## ncurses 6.4+20231209

=== debian/changelog ===
ncurses (6.4+20231209-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Remove xterm+sm+1006 from tmux (Closes: #1057688).
    - Update man/edit_man.sh to allow for "\%" markers embedded after
      bold font escapes in manpage cross-references (Closes: #1057651).

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 11 Dec 2023 17:03:08 +0100

ncurses (6.4+20231121-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Amend fix for #1055882, correcting nul terminator check in
      waddnstr (Closes: #1056340).

 -- Sven Joachim <svenjoac@gmx.de>  Wed, 22 Nov 2023 17:10:27 +0100

ncurses (6.4+20231118-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Modify reset command to avoid altering clocal if the terminal uses
      a modem (prompted by discussion with Werner Fink, Michal Suchanek,
      Closes: #60377).
    - Correct loop termination condition in waddnstr() and waddnwstr()
      (Closes: #1055882).
  * Refresh Debian patches.
    - Drop the workaround for #933053 from patch 02-debian-xterm.diff,
      it had been non-functional since version 6.2+20210905-1.
  * Move all libraries below /usr (Closes: #1055940).
  * Install libtermcap.so as a symlink rather than a linker script.
  * Explicitly configure the non-wide builds with --disable-widec.

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 20 Nov 2023 17:30:14 +0100

ncurses (6.4+20231016-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Make the recent change to setupterm optional and disable it
      by default (Closes: #1054022).

 -- Sven Joachim <svenjoac@gmx.de>  Tue, 17 Oct 2023 17:34:56 +0200

ncurses (6.4+20231007-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Improve manual description of immedok (Closes: #1053603).
    - Fix a few formatting issues with manpages (Closes: #1053123).
  * Update libtinfo6 symbols file, adding eight new symbols.
  * Refresh Debian patches.
  * Set BUILD_{C,CPP,LD}FLAGS for the native architecture to fix cross
    builds which had been broken on arm64 and amd64 by changes in
    dpkg-buildflags 1.22.0.

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 12 Oct 2023 17:07:15 +0200

=== debian/rules ===
--- 
+++ 
@@ -11,9 +11,10 @@
 export CPPFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get CPPFLAGS)
 export CXXFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get CXXFLAGS)
 export LDFLAGS := $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get LDFLAGS)
-export BUILD_CFLAGS := $(CFLAGS)
-export BUILD_CPPFLAGS := $(CPPFLAGS)
-export BUILD_LDFLAGS := $(LDFLAGS)
+export BUILD_CFLAGS := $(shell DEB_HOST_ARCH=`dpkg --print-architecture` dpkg-buildflags --get CFLAGS)
+export BUILD_CPPFLAGS := $(shell DEB_HOST_ARCH=`dpkg --print-architecture` dpkg-buildflags --get CPPFLAGS)
+export BUILD_LDFLAGS := $(shell DEB_HOST_ARCH=`dpkg --print-architecture` \
+				DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow dpkg-buildflags --get LDFLAGS)
 export ARFLAGS = -crv
 
 include /usr/share/dpkg/architecture.mk
@@ -62,8 +63,6 @@
 wobjdir-32=$(srcdir)/obj-wide-32
 wobjdir-64=$(srcdir)/obj-wide-64
 objdir-test=$(srcdir)/obj-test
-
-autogen-files := debian/libtermcap.so
 
 ifeq ($(DEB_HOST_ARCH),i386)
 build_64_target = x86_64-$(DEB_HOST_GNU_SYSTEM)
@@ -180,14 +179,16 @@
 	test -d $(objdir) || mkdir $(objdir)
 	cd $(objdir) && $(relsrcdir)/configure \
 		$(CONFARGS) \
-		--without-normal
+		--without-normal \
+		--disable-widec
 
 $(objdir-static)/config.status: config.guess-stamp
 	test -d $(objdir-static) || mkdir $(objdir-static)
 	cd $(objdir-static) && $(relsrcdir)/configure \
 		$(CONFARGS) \
 		--without-shared \
-		--without-gpm
+		--without-gpm \
+		--disable-widec
 
 $(objdir-32)/config.status: config.guess-stamp
 	test -d $(objdir-32) || mkdir $(objdir-32)
@@ -200,6 +201,7 @@
 		$(CONFARGS) \
 		--host=$(build_32_target) \
 		--without-gpm \
+		--disable-widec \
 		--libdir=/usr/lib32
 
 $(objdir-64)/config.status: config.guess-stamp
@@ -213,6 +215,7 @@
 		$(CONFARGS) \
 		--host=$(build_64_target) \
 		--without-gpm \
+		--disable-widec \
 		--libdir=/usr/lib64
 
 $(wobjdir)/config.status: config.guess-stamp
@@ -262,11 +265,3 @@
 $(objdir-test)/config.status: build-wide config.guess-stamp
 	test -d $(objdir-test) || mkdir $(objdir-test)
 	export LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(wobjdir)/lib && \
-	cd $(objdir-test) && \
-		PKG_CONFIG_LIBDIR=$(wobjdir)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
-		$(relsrcdir)/test/configure $(CONFARGS-TEST)
-
-build-indep: build-normal build-wide
-	touch $@
-
-build-arch build: build-indep build-static build-wide-static $(build_examples) \

## ncurses 6.4+20240113

=== debian/changelog ===
ncurses (6.4+20240113-1ubuntu2) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:14:03 +0200

ncurses (6.4+20240113-1ubuntu1) noble; urgency=medium

  * d/t/control: Disable failing superficial autopkgtest on i386 (LP: #2052951)

 -- Mate Kukri <mate.kukri@canonical.com>  Mon, 12 Feb 2024 10:12:36 +0000

ncurses (6.4+20240113-1) unstable; urgency=medium

  * New upstream patchlevel.
  * Refresh Debian patches.
  * Update years in debian/copyright.
  * Install ncurses6-config.1 via "make install" to ensure it contains
    correct cross-references (Closes: #1060211).
  * Add a regression autopkgtest to ensure that there are no '3X'
    references in manpages (see #618429, #1004901, #1057651, #1060211).
  * Build-Depend on pkgconf rather than on pkg-config.
  * Drop kfreebsd-specific code from debian/rules.

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 15 Jan 2024 20:34:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: ncurses
 Section: libs
 Priority: required
-Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
 Uploaders: Sven Joachim <svenjoac@gmx.de>, Craig Small <csmall@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libgpm-dev [linux-any],
-               pkg-config,
+               pkgconf,
                autoconf-dickey (>= 2.52+20210509),
 Build-Depends-Arch: g++-multilib [amd64 i386 powerpc ppc64 s390 sparc] <!nobiarch>
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -105,10 +105,6 @@
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 with_mouse = --with-gpm
-else
-ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
-with_mouse = --without-sysmouse
-endif
 endif
 
 CONFARGS =	--prefix=/usr \
@@ -265,3 +261,4 @@
 $(objdir-test)/config.status: build-wide config.guess-stamp
 	test -d $(objdir-test) || mkdir $(objdir-test)
 	export LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(wobjdir)/lib && \
+	cd $(objdir-test) && \

## ncurses 6.4+20240113-1ubuntu2trisquel2

=== debian/changelog ===
ncurses (6.4+20240113-1ubuntu2trisquel2) ecne; urgency=medium

  * Rebuild as udeb dependency for debian-installer and patch
    dh_autoreconf.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 11 Sep 2024 17:46:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ncurses
 Section: libs
 Priority: required
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
 Uploaders: Sven Joachim <svenjoac@gmx.de>, Craig Small <csmall@debian.org>
 Build-Depends: debhelper-compat (= 13),

## ncurses 6.5

=== debian/changelog ===
ncurses (6.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 09 May 2024 10:58:21 +0200

ncurses (6.5-1) experimental; urgency=medium

  * New upstream release.
  * Update symbols files and bump shlibs.
    - Update the minimal version for symbols added after the 6.4 release
      to 6.5.
  * Update patch 01-debian-no-ada-doc.diff for the changed location of the
    Ada documentaton.

 -- Sven Joachim <svenjoac@gmx.de>  Sun, 05 May 2024 18:31:39 +0200

ncurses (6.4+20240414-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Fix inconsistent description of wmouse_trafo() (Closes: #1059778).
    - Modify wenclose() to handle pads (Closes: #1059783).
    - Improve manpage discussion of mouseinterval() (Closes: #1058560).
  * Add a new "terminfocheck" target to debian/rules to compare the built
    terminfo files against the system database, and use it in binary-indep
    builds in a new pkg.ncurses.terminfocheck build profile.
  * Add a smoke autopkgtest for infocmp, testing that its output for the
    'dumb' terminfo entry matches expectations (see #868266).
  * Add another smoke autopkgtest to ensure that the backspace/delete key
    definitions match expectations (see Policy §9.8).
  * If DEB_BUILD_OPTIONS matches "terse", configure with --disable-echo.
  * Stop patching terminfo.src for the Debian-specific terminfo aliases
    xterm-debian and rxvt-m, create symlinks for them instead.
    - Drop patch 02-debian-xterm.diff.
    - Merge patch 02-debian-rxvt.diff into 02-debian-backspace.diff.
  * Refresh patch 02-debian-backspace.diff.
  * Upgrade Standards-Version to 4.7.0, no changes needed.

 -- Sven Joachim <svenjoac@gmx.de>  Tue, 16 Apr 2024 21:28:36 +0200

## ncurses 6.5%2B20251122

=== debian/changelog ===
ncurses (6.5+20251122-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Correct expression for TINFO_LIB variable in misc/ncurses-config.in
      (Closes: #1121208).
  * Add a smoke autopkgtest which builds a simple program, catching the
    above problem.

 -- Sven Joachim <svenjoac@gmx.de>  Sun, 23 Nov 2025 14:55:47 +0100

ncurses (6.5+20251115-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 20 Nov 2025 20:52:35 +0100

ncurses (6.5+20251115-1) experimental; urgency=low

  * New upstream patchlevel.
    - Add a buffer-limit check in postprocess_termcap (report/testcase
      by Yifan Zhang (CVE-2025-6141, Closes: #1107937)).
    - Formatting improvements for terminfo.5 (Closes: #1096164).
  * Refresh patch 02-debian-backspace.diff.
  * Drop the redundant Rules-Requires-Root field from debian/control.

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 17 Nov 2025 18:46:28 +0100

ncurses (6.5+20250216-2) unstable; urgency=medium

  * Update upstream signing key.
  * Upgrade Standards-Version to 4.7.2, no changes needed.

 -- Sven Joachim <svenjoac@gmx.de>  Thu, 06 Mar 2025 17:01:55 +0100

ncurses (6.5+20250216-1) unstable; urgency=medium

  * New upstream patchlevel.

 -- Sven Joachim <svenjoac@gmx.de>  Tue, 18 Feb 2025 17:01:53 +0100

ncurses (6.5+20250125-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sven Joachim <svenjoac@gmx.de>  Fri, 31 Jan 2025 16:55:43 +0100

ncurses (6.5+20250125-1) experimental; urgency=low

  * New upstream patchlevel.
  * Refresh Debian patches.
  * Update years in debian/copyright.

 -- Sven Joachim <svenjoac@gmx.de>  Wed, 29 Jan 2025 17:00:06 +0100

## ncurses 6.5+20250125

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: ncurses
 Section: libs
 Priority: required
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
-XSBC-Original-Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
+Maintainer: Ncurses Maintainers <ncurses@packages.debian.org>
 Uploaders: Sven Joachim <svenjoac@gmx.de>, Craig Small <csmall@debian.org>
 Build-Depends: debhelper-compat (= 13),
                libgpm-dev [linux-any],
                pkgconf,
                autoconf-dickey (>= 2.52+20210509),
 Build-Depends-Arch: g++-multilib [amd64 i386 powerpc ppc64 s390 sparc] <!nobiarch>
-Standards-Version: 4.6.2
+Build-Depends-Indep: ncurses-term <pkg.ncurses.terminfocheck>
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/ncurses
 Vcs-Git: https://salsa.debian.org/debian/ncurses.git

## ncurses 6.5+20250216

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 # These are important since this is a library package
 soname=6
-sodepver = (>= 6.3+20220423)
+sodepver = (>= 6.5)
 
 # Name our packages
 package-base=ncurses-base
@@ -103,6 +103,14 @@
 build_examples = build-test
 endif
 
+ifneq (,$(filter pkg.ncurses.terminfocheck,$(DEB_BUILD_PROFILES)))
+check_ti = terminfocheck
+endif
+
+ifneq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
+echo = --disable-echo
+endif
+
 ifeq ($(DEB_HOST_ARCH_OS),linux)
 with_mouse = --with-gpm
 endif
@@ -113,7 +121,8 @@
 		--mandir=/usr/share/man \
 		--with-manpage-format=normal \
 		--without-profile --without-debug \
-		--disable-rpath --enable-echo \
+		--disable-rpath \
+		$(echo) \
 		--disable-stripping \
 		--enable-const \
 		--enable-pc-files \
@@ -144,6 +153,7 @@
 		--bindir=/usr/libexec/ncurses-examples \
 		--datadir=/usr/share/ncurses-examples \
 		--disable-stripping \
+		$(echo) \
 		--with-x11-rgb=/etc/X11/rgb.txt \
 		--with-ncursesw \
 		--with-curses-dir=$(wobjdir)
@@ -259,6 +269,3 @@
 		--libdir=/usr/lib64
 
 $(objdir-test)/config.status: build-wide config.guess-stamp
-	test -d $(objdir-test) || mkdir $(objdir-test)
-	export LD_LIBRARY_PATH=$${LD_LIBRARY_PATH}:$(wobjdir)/lib && \
-	cd $(objdir-test) && \

=== debian/tests/control ===
Tests: manpage-references
Restrictions: superficial
Depends: libncurses-dev, ncurses-bin, ncurses-doc

Tests: backspace-delete-keys, infocmp-dumb
Restrictions: superficial
Depends: ncurses-base, ncurses-bin

## ncurses 6.5+20251115

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,7 @@
                autoconf-dickey (>= 2.52+20210509),
 Build-Depends-Arch: g++-multilib [amd64 i386 powerpc ppc64 s390 sparc] <!nobiarch>
 Build-Depends-Indep: ncurses-term <pkg.ncurses.terminfocheck>
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/ncurses
 Vcs-Git: https://salsa.debian.org/debian/ncurses.git
 Homepage: https://invisible-island.net/ncurses/

## ncurses 6.5+20251123

=== debian/changelog ===
ncurses (6.5+20251123-1) unstable; urgency=medium

  * New upstream patchlevel.
    - Revert change using NCURSES_SBOOL in tic.h which interfered with
      sign-extension in tigetflag (Closes: #1121191).

 -- Sven Joachim <svenjoac@gmx.de>  Mon, 24 Nov 2025 20:50:02 +0100

## ncurses 6.6+20251231

=== debian/changelog ===
ncurses (6.6+20251231-1) unstable; urgency=medium

  * New upstream patchlevel.
  * Update symbols files and bump shlibs.
  * Upgrade Standards-Version to 4.7.3, no changes needed.

 -- Sven Joachim <svenjoac@gmx.de>  Sat, 03 Jan 2026 08:53:58 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                autoconf-dickey (>= 2.52+20210509),
 Build-Depends-Arch: g++-multilib [amd64 i386 powerpc ppc64 s390 sparc] <!nobiarch>
 Build-Depends-Indep: ncurses-term <pkg.ncurses.terminfocheck>
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/ncurses
 Vcs-Git: https://salsa.debian.org/debian/ncurses.git
 Homepage: https://invisible-island.net/ncurses/

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 
 # These are important since this is a library package
 soname=6
-sodepver = (>= 6.5)
+sodepver = (>= 6.6)
 
 # Name our packages
 package-base=ncurses-base

=== debian/tests/control ===
--- 
+++ 
@@ -5,3 +5,7 @@
 Tests: backspace-delete-keys, infocmp-dumb
 Restrictions: superficial
 Depends: ncurses-base, ncurses-bin
+
+Tests: build
+Restrictions: superficial
+Depends: libncurses-dev, gcc, pkgconf

## ncurses programs

=== Makefile ===
# The top level Makefile

MAKE_RECUR = $(MAKE) CC=$(CC) CFLAGS=$(CFLAGS)

all:	
	( cd JustForFun && $(MAKE_RECUR) )
	( cd basics	&& $(MAKE_RECUR) )
	( cd forms	&& $(MAKE_RECUR) )
	( cd menus	&& $(MAKE_RECUR) )
	( cd panels	&& $(MAKE_RECUR) )
	@echo 
	@echo "*********************************************"
	@echo "All files Built"
	@echo "Please move to demo/exe directory"
	@echo "Execute each file to see examples in action"
	@echo "*********************************************"
	@echo
clean:
	( cd JustForFun && $(MAKE_RECUR) $@ )
	( cd basics	&& $(MAKE_RECUR) $@ )
	( cd forms	&& $(MAKE_RECUR) $@ )
	( cd menus	&& $(MAKE_RECUR) $@ )
	( cd panels	&& $(MAKE_RECUR) $@ )
	rm -rf demo

=== JustForFun/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/hanoi \
	${EXE_DIR}/life\
	${EXE_DIR}/magic \
	${EXE_DIR}/queens \
	${EXE_DIR}/shuffle \
	${EXE_DIR}/tt

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}

clean:
	@rm -f ${EXES}

=== basics/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/acs_vars \
	${EXE_DIR}/hello_world \
	${EXE_DIR}/init_func_example \
	${EXE_DIR}/key_code \
	${EXE_DIR}/mouse_menu \
	${EXE_DIR}/other_border \
	${EXE_DIR}/printw_example \
	${EXE_DIR}/scanw_example \
	${EXE_DIR}/simple_attr \
	${EXE_DIR}/simple_color \
	${EXE_DIR}/simple_key \
	${EXE_DIR}/temp_leave \
	${EXE_DIR}/win_border \
	${EXE_DIR}/with_chgat

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}

clean:
	@rm -f ${EXES}

=== forms/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lform -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/form_attrib\
	${EXE_DIR}/form_options\
	${EXE_DIR}/form_simple\
	${EXE_DIR}/form_win \

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}

=== menus/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lmenu -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/menu_attrib\
	${EXE_DIR}/menu_item_data\
	${EXE_DIR}/menu_multi_column \
	${EXE_DIR}/menu_scroll \
	${EXE_DIR}/menu_simple \
	${EXE_DIR}/menu_toggle \
	${EXE_DIR}/menu_userptr \
	${EXE_DIR}/menu_win

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}

=== panels/Makefile ===
# Makefile for JustForFun Files

# A few variables

CC=gcc
LIBS=-lpanel -lncurses

SRC_DIR=.
EXE_DIR=../demo/exe

EXES = \
	${EXE_DIR}/panel_browse \
	${EXE_DIR}/panel_hide \
	${EXE_DIR}/panel_resize \
	${EXE_DIR}/panel_simple

${EXE_DIR}/%: %.o
	@mkdir -p ${EXE_DIR}
	${CC} -o $@ $< ${LIBS}

%.o: ${SRC_DIR}/%.c
	${CC} -o $@ $(CFLAGS) $(CPPFLAGS) -c $<

all:    ${EXES}


clean:
	@rm -f ${EXES}
